import { OnDestroy } from '@angular/core';
import { ControlValueAccessor, FormControl } from '@angular/forms';
import { Observable } from 'rxjs';
import { DataSource, OptionEntry } from './types';
export declare class SearchSelectBase implements ControlValueAccessor, OnDestroy {
    debounceTime: number;
    set dataSource(ds: DataSource);
    searchControl: FormControl;
    loading: Observable<boolean>;
    list: Observable<OptionEntry[] | undefined>;
    empty: Observable<boolean>;
    errorMessage: Observable<string | undefined>;
    focus(): void;
    blur(): void;
    displayWith(value: OptionEntry): string;
    private incomingValues;
    private incomingDataSources;
    private incomingDataSourcesSub;
    private outsideValue;
    private selectedValueSub;
    private selectedValue;
    constructor();
    writeValue(obj: any): void;
    registerOnChange(fn: any): void;
    registerOnTouched(fn: any): void;
    setDisabledState(isDisabled: boolean): void;
    ngOnDestroy(): void;
    private onChange;
    private onTouched;
    private checkAndPropagate;
}
